<?php

// api doc https://h.wandouip.com/get/api

$ch = curl_init();

$params = [
    // 账户密钥
    "app_key" => "",
    // 指定套餐，默认不指定
    "pack"    => "0",
    // 获取代理IP数量
    "num"     => "20",
    // 代理协议 http协议: 1
    "xy"      => "1",
    // 格式 txt格式: 1
    "type"    => "1",
    // 支持自定义间隔符
    "lb"      => "\r\n",
    // 是否去重，默认不去重，不去重=0，去重=99
    "nr"      => "0",
    // 指定地区，默认全国，支持指定省或市，支持同时指定多个，英文符号 | 分隔
    // 全国: 0
    // 北京市: 110000
    // 北京市+江苏省+杭州市: 110000|320000|330100
    "area_id" => "0",
];


// 设置请求地址
curl_setopt($ch, CURLOPT_URL, "https://api.wandoudl.com/api/ip/list-v2?" . http_build_query($params));
// https请求 不验证证书和hosts
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
// 响应内容返回而不是直接输出
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
// 请求超时时间 秒
curl_setopt($ch, CURLOPT_TIMEOUT, 30);
// 发出网络请求
$output = curl_exec($ch);
if ($output === FALSE) {
    // 网络请求失败
    echo "CURL Fail:\terror:" . curl_error($ch) . "\terrno:" . curl_errno($ch), PHP_EOL;
} else {
    // 判断是否获取失败，空返回
    if (empty($output)) {
        echo "Warning:\tEmpty Proxy Address List" . PHP_EOL;
        return;
    }
    // 判断是否获取失败，有错误信息
    if (strpos($output, "{") === 0) {
        $response = json_decode($output, true);
        echo "Error Response:\tcode:", $response["code"], "\tmsg:", $response["msg"], PHP_EOL;
        return;
    }
    // 使用自定义换行符分割
    $proxyAddrList = explode("\r\n", $output);

    echo "Obtain total proxy addresses:\t" . count($proxyAddrList), PHP_EOL;
    // 设置需要通过代理请求的网址
    curl_setopt($ch, CURLOPT_URL, "https://myip.ipip.net");

    foreach ($proxyAddrList as $proxyAddr) {
        // 设置代理地址，格式  http://ip:port
        curl_setopt($ch, CURLOPT_PROXY, "http://$proxyAddr");
        // 通过代理发出网络请求
        $output = curl_exec($ch);
        // 判断请求结果
        if ($output) {
            echo trim($output), PHP_EOL;
        } else {
            echo "Proxy Fail:\tproxy:", $proxyAddr, "\terror:", curl_error($ch), "\terrno:", curl_errno($ch), PHP_EOL;
        }
    }
}
curl_close($ch);
